"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getNgrams = exports.getTokens = void 0;
const config_1 = require("./config");
const getTokens = (str) => {
    let strSpaced = str;
    for (const punctuation of config_1.PUNCTUATION_MARKS) {
        strSpaced = strSpaced.replace(config_1.PUNCTUATION_REGEX[punctuation], ` ${punctuation} `);
    }
    strSpaced = strSpaced.replace(/ {2,}/g, ' ').trim();
    const tokens = strSpaced.split(' ');
    return tokens.map(item => item.trim()).filter(item => !!item);
};
exports.getTokens = getTokens;
const getNgrams = (n, str, onGramFound) => {
    const tokens = (0, exports.getTokens)(str);
    const filler = Array(n - 1).fill(config_1.START_TOKEN);
    const filledTokens = filler.concat(tokens);
    const tokensCount = filledTokens.length;
    for (let i = 0; i <= tokensCount - n; i++) {
        const nTokens = filledTokens.slice(i, i + n);
        const gram = {
            current: nTokens.slice(0, n - 1),
            next: nTokens[nTokens.length - 1],
        };
        onGramFound(gram);
    }
};
exports.getNgrams = getNgrams;
//# sourceMappingURL=helpers.js.map